#!/bin/sh
#@***h* GPCPcdr_ECPm_DiagPlots.sh
#       Global Precipitation Climatology Project (GPCP)
#
# NAME
#   GPCPcdr_ECPm_DiagPlots.sh
#
# PURPOSE
#   To produce diagnostic plots of the Monthly GPCP input data 
#
# DESCRIPTION
# This script runs matlab code that produces diagnostic plots of the GPCP input data
# Note that output is stored in GPCP_Output or NRT/GPCP_Output
# Written by MRP Sapiano
# may need to update the location of matlab - type "whereis matlab" at the unix command line
# AUTHOR
#   Robert Adler, Mathew Sapiano, Jian-Jian Wang
#   University of Maryland College Park
#
# COPYRIGHT
#   THIS SOFTWARE AND ITS DOCUMENTATION ARE CONSIDERED TO BE IN THE PUBLIC
#   DOMAIN AND THUS ARE AVAILABLE FOR UNRESTRICTED PUBLIC USE. THEY ARE
#   FURNISHED "AS IS." THE AUTHORS, THE UNITED STATES GOVERNMENT, ITS
#   INSTRUMENTALITIES, OFFICERS, EMPLOYEES, AND AGENTS MAKE NO WARRANTY,
#   EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE SOFTWARE AND
#   DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
#   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL
#   SUPPORT TO USERS.
#
# HISTORY
# 3/2016 Initial Version prepared for NCEI
#
#@*****

# Diagnostic plots for Interim files
/usr/bin/matlab -nodesktop -nodisplay -nosplash < GPCPcdr_m5/GPCPcdr_m5_DiagPlots/GPCPcdr_m5_DiagPlots_Interim.m 

# Diagnostic plots for CDR files
/usr/bin/matlab -nodesktop -nodisplay -nosplash < GPCPcdr_m5/GPCPcdr_m5_DiagPlots/GPCPcdr_m5_DiagPlots_CDR.m 

# Diagnostic plots for ICDR files
#/usr/local/bin/matlab -nodesktop -nodisplay -nosplash < GPCPcdr_m5/GPCPcdr_m5_DiagPlots/GPCPcdr_m5_DiagPlots_ICDR.m 



