#!/bin/sh
#@***h* GPCPcdr_ECPm_TestOutputs.sh
#       Global Precipitation Climatology Project (GPCP)
#
# NAME
#   GPCPcdr_ECPm_TestOutputs.sh
#
# PURPOSE
#   To check whether the ICDR and CDR files contain corrupted data
#
# DESCRIPTION
# This script runs matlab code that checks whether the ICDR and CDR files
# contain corrupted data. A summary of possible corrupted data is printed
# to the screen and a full summary is saved to a text file.
#
# GPCPcdr_ECPm_TestOutputs.sh
#
# may need to update the location of matlab - type "whereis matlab" at the unix command line
# AUTHOR
#   Robert Adler, Mathew Sapiano, Jian-Jian Wang
#   University of Maryland College Park
#
# COPYRIGHT
#   THIS SOFTWARE AND ITS DOCUMENTATION ARE CONSIDERED TO BE IN THE PUBLIC
#   DOMAIN AND THUS ARE AVAILABLE FOR UNRESTRICTED PUBLIC USE. THEY ARE
#   FURNISHED "AS IS." THE AUTHORS, THE UNITED STATES GOVERNMENT, ITS
#   INSTRUMENTALITIES, OFFICERS, EMPLOYEES, AND AGENTS MAKE NO WARRANTY,
#   EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE SOFTWARE AND
#   DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
#   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL
#   SUPPORT TO USERS.
#
# HISTORY
# 3/2016 Initial Version prepared for NCEI
#
#@*****


/usr/bin/matlab -nosplash -nodisplay -nodesktop -r "path(path,'GPCPcdr_m5/GPCPcdr_m5_TestOutput/'); GPCP_M5_test_all_data; exit;" 






