#/bin/sh
#@***h* GPCPcdr_ECPm_m5_Products.sh
#       Global Precipitation Climatology Project (GPCP)
#
# NAME
#   GPCPcdr_ECPm_m5_Products.sh
#
# PURPOSE
#   To produce plots for the CDR/ICDR website
#
# DESCRIPTION
# This script runs matlab code that produces plots for the CDR/ICDR website
#
# GPCPcdr_ECPm_m5_Products.sh 2014 10
#
# may need to update the location of matlab - type "whereis matlab" at the unix command line
# AUTHOR
#   Robert Adler, Mathew Sapiano, Jian-Jian Wang
#   University of Maryland College Park
#
# COPYRIGHT
#   THIS SOFTWARE AND ITS DOCUMENTATION ARE CONSIDERED TO BE IN THE PUBLIC
#   DOMAIN AND THUS ARE AVAILABLE FOR UNRESTRICTED PUBLIC USE. THEY ARE
#   FURNISHED "AS IS." THE AUTHORS, THE UNITED STATES GOVERNMENT, ITS
#   INSTRUMENTALITIES, OFFICERS, EMPLOYEES, AND AGENTS MAKE NO WARRANTY,
#   EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE SOFTWARE AND
#   DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
#   THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL
#   SUPPORT TO USERS.
#
# HISTORY
# 3/2016 Initial Version prepared for NCEI
#
#@*****

# copy inputs into permanent variables
yyyy=$1
mm=$2


# Create Means, Anomalies and Percent of Normal plots
/usr/bin/matlab -nosplash -nodisplay -nodesktop -r "path(path,'GPCPcdr_m5/GPCPcdr_m5_Products/'); GPCPcdr_m5_Products_All($yyyy,$mm); exit;"

# Create SPI plots
/usr/bin/matlab -nosplash -nodisplay -nodesktop -r "path(path,'GPCPcdr_m5/GPCPcdr_m5_Products/'); GPCPcdr_m5_Products_SPI($yyyy,$mm); exit;"

# Create ESPI data and plots
/usr/bin/matlab -nosplash -nodisplay -nodesktop -r "path(path,'GPCPcdr_m5/GPCPcdr_m5_Products/'); GPCPcdr_m5_Products_ESPI(); exit;"



