#!/bin/sh
#
# Get AIRS data for a single month
#
# ftp_AIRS.sh 2012 01


yyyy=$1
mm=$2


# cd to output directory
cd /data/radler/msapiano/GPCP_CDR_Data/GPCP_Input/AIRS_V5
echo "Output sent to: /data/radler/msapiano/GPCP_CDR_Data/GPCP_Input/AIRS_V5"
if [ ! -d $yyyy ]; then
  mkdir $yyyy
fi
cd $yyyy
if [ ! -d $mm ]; then
  mkdir $mm
fi
cd $mm


# scroll through all possible days
for dd in 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31
do
  
  # get day of year; suppress warnings when day of month does not exist
  if ddd=`date -d "${mm}/${dd}/${yyyy}" +%j 2>/dev/null`; then

    # wget data from ftp site
    wget -nv ftp://airspar1u.ecs.nasa.gov/data/s4pa/Aqua_AIRS_Level2/AIRG2SSD.005/${yyyy}/${ddd}/*.hdf

  fi
done





