#!/bin/sh
#
# Get AIRS data for a single month
#
# ftp_AIRS_V6.sh 2012 01


yyyy=$1
mm=$2

InputPATH=$(echo `grep "InputPATH" ../OptionsM.h` | awk -F\"  '{print $2}')

# cd to output directory
cd ${InputPATH}/AIRS_V6
echo "Output sent to: ${InputPATH}/AIRS_V6"
if [ ! -d $yyyy ]; then
  mkdir $yyyy
fi
cd $yyyy
if [ ! -d $mm ]; then
  mkdir $mm
fi
cd $mm


# scroll through all possible days
for dd in 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31
do
  
  # get day of year; suppress warnings when day of month does not exist
  if ddd=`date -d "${mm}/${dd}/${yyyy}" +%j 2>/dev/null`; then

    # wget data from ftp site
#   wget -vN ftp://airspar1u.ecs.nasa.gov/data/s4pa/Aqua_AIRS_Level2/AIRG2SSD.006/${yyyy}/${ddd}/*.hdf
    wget -vN ftp://airsl2.gesdisc.eosdis.nasa.gov/data/s4pa/Aqua_AIRS_Level2/AIRG2SSD.006/${yyyy}/${ddd}/*.hdf

  fi
done





