#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "../OptionsM.h"

/* This code opens the Ferraro data file and checks that 
 *    data exists for the required month     */

int main(int argc, char *argv[])
{
  int    yyyy, mm;      /* Input year and month */
  char   fname[500];
  float  data[144][72];
  float  sum;
  FILE  *fopen(), *fp;
  int    i, j, test, offset;

  /* Convert inputs to integer and check that they are valid */
  yyyy = atoi(argv[1]);
  mm   = atoi(argv[2]);

  if ((yyyy<1979)||(yyyy>2050)) {
    fprintf(stderr,"Year (%d) outside of valid range [1979-2050])\n",yyyy);
    exit(EXIT_FAILURE);
  }
  if ((mm<1)||(mm>12)) {
    fprintf(stderr,"month (%d) outside of valid range\n",mm);
    exit(EXIT_FAILURE);
  }

  /* Get filename and read data */
  sprintf(fname,"%s/Ferraro/PR1.MON",InputPATH);

  fp = fopen(fname,"r");
  if (fp == NULL) {
    fprintf(stderr,"Can't open file: %s\n",fname);
    exit(EXIT_FAILURE);
  }

  /* calculate offset and check that it is not beyond EOF */
  offset=((yyyy-1987)*12+(mm-1))*4*144*72;
  fseek(fp,0,SEEK_END);
  test=ftell(fp);
  /* If record is beyond EOF, output zero value */
  if (test<=offset) {
    printf("0\n");
    exit(0);
  }

  /* skip to record and read data */
  fseek(fp,offset,SEEK_SET);
  fread(data,4,144*72,fp);

  /* close file */
  fclose(fp);  


  /* sum non-missing data */
  sum=0;
  for (i=0; i<144; i++) {
    for (j=0; j<72; j++) {
      if (data[i][j]>=0) {
        sum=sum+data[i][j];
      }
    }
  }

  /* Exit and return sum */
  printf("%d\n",(int)ceilf(sum));
  return(0);
}

