#!/bin/sh
#
# Get file listings for each input dataset

# rename inputs
yyyy=$1
mm=$2
sat=$3


# Read location of files from params.h
InputPATH=$(echo `grep "InputPATH" OptionsM.h` | awk -F\"  '{print $2}')



# read RSS v6 SSMI Tb files and output to file listing file
# Need to read file from last day of previous month 
# and first file of next month
yyyy_m1=`date -d "${yyyy}-${mm}-01 -1day" "+%Y"`
yyyy_p1=`date -d "${yyyy}-${mm}-01 +1month" "+%Y"`
mm_m1=`date -d "${yyyy}-${mm}-01 -1day" "+%m"`
mm_p1=`date -d "${yyyy}-${mm}-01 +1month" "+%m"`
dd_m1=`date -d "${yyyy}-${mm}-01 -1day" "+%d"`
dd_p1=`date -d "${yyyy}-${mm}-01 +1month" "+%d"`

if [ $yyyy$mm -ge 198707 ] && [ $yyyy$mm -le 200812 ] ; then
  ls -1 ${InputPATH}/SSMI_RSS_NCDCcdr_TbV6/${sat}/${yyyy_m1}/${mm_m1}/*D${yyyy_m1}${mm_m1}${dd_m1}_*.nc > file_listings/RSS_Tb_${sat}_${yyyy}${mm}.list
  ls -1 ${InputPATH}/SSMI_RSS_NCDCcdr_TbV6/${sat}/${yyyy}/${mm}/*.nc >> file_listings/RSS_Tb_${sat}_${yyyy}${mm}.list
  ls -1 ${InputPATH}/SSMI_RSS_NCDCcdr_TbV6/${sat}/${yyyy_p1}/${mm_p1}/*D${yyyy_p1}${mm_p1}${dd_p1}_*.nc >> file_listings/RSS_Tb_${sat}_${yyyy}${mm}.list
elif [ $yyyy$mm -ge 200901 ] ; then
  ls -1 ${InputPATH}/SSMIS_RSS_NCDCcdr_TbV7/${sat}/${yyyy_m1}/${mm_m1}/*D${yyyy_m1}${mm_m1}${dd_m1}_*.nc > file_listings/RSS_Tb_${sat}_${yyyy}${mm}.list
  ls -1 ${InputPATH}/SSMIS_RSS_NCDCcdr_TbV7/${sat}/${yyyy}/${mm}/*.nc >> file_listings/RSS_Tb_${sat}_${yyyy}${mm}.list
  ls -1 ${InputPATH}/SSMIS_RSS_NCDCcdr_TbV7/${sat}/${yyyy_p1}/${mm_p1}/*D${yyyy_p1}${mm_p1}${dd_p1}_*.nc >> file_listings/RSS_Tb_${sat}_${yyyy}${mm}.list
else
  echo "Time period is before SSMI/SSMIS period: file listing not produced."
fi



# get listing of Merged IR files for corr2
if [ $yyyy$mm -lt 199610 ] ; then
  echo "Time period is before 199610; mergIR 3hrly file listing not produced."
else
  ls -1 ${InputPATH}/mergIR_3hr_1deg/${yyyy}/${mm}/hr* > file_listings/mergIR_3hr_1deg_${yyyy}${mm}.list
fi