      subroutine Read_GPCCv6_ASCII(cinfname, csflag, gauge, gaugen)
c     Code to read GPCC Full version 6 and Monitoring V4 data
c     from ASCII files
c
c     Inputs:
c       cinfname   Name of input file
c       gauge      GPCC gauge precip
c       gaugen     GPCC number of gauges



      INTEGER*4 inunit
      LOGICAL   opn

      CHARACTER*256     cinfname
      CHARACTER*1       csflag

      REAL*4  gauge(144,72), gaugen(144,72), 
     +    tempg(144,72), tempgn(144,72)




C     Open the ASCII monthly gauge file which contains the gauge 
C     analysis and the number of gauges.



c     get unused unit number
      inunit = 0
      opn = .TRUE.
      DO WHILE (opn)
         inunit = inunit + 1
         INQUIRE(inunit, OPENED = opn)
      END DO


c     open file
      OPEN (UNIT = inunit, ACCESS = 'SEQUENTIAL', FILE = cinfname,
     +        FORM = 'FORMATTED', IOSTAT = ios)

      if ( ios .NE. 0 ) then
         WRITE(*,*) 'Error in GPCPcdr_m2_Adjust_Gauge:'//
     &        'Failed to open input ASCII gauge file'
         STOP
      endif



C       The data is GPCC and is at the 2.5 degree resolution.  Begin
C       reading by determining the number of header lines, and rereading
C       the file ignoring the headers.
C
      icount = 0
      ios = 0
C     
      do while (ios .EQ. 0)
         READ (inunit, 200, IOSTAT = ios) cdummy
         if ( ios .NE. 0 .AND. ios .NE. -1 ) then
            WRITE(*,*) 'Error in GPCPcdr_m2_Adjust_Gauge:'//
     &           'Failed to read input ASCII gauge file'
            STOP
         endif
         if ( ios .EQ. -1 ) then
            EXIT
         endif
         icount = icount + 1
      end do

C     
      nskip = icount - 10368
      REWIND (inunit)
C     
      IF  (nskip .NE. 0) THEN
         DO i = 1, nskip
            READ (inunit, 200, IOSTAT = ios) cdummy
            if ( ios .NE. 0 .AND. ios .NE. -1 ) then
               WRITE(*,*) 'Error in GPCPcdr_m2_Adjust_Gauge:'//
     &              'Failed to read input ASCII gauge file'
               STOP
            endif
         END DO
      END IF
C     
      IF  (csflag .EQ. 'M') THEN
C     
         DO j = 1, 72
            DO i = 1, 144
               READ (inunit, *, IOSTAT = ios)
     +              gauge(i,j), gaugen(i,j)
               if ( ios .NE. 0 .AND. ios .NE. -1 ) then
                  WRITE(*,*) 'Error in GPCPcdr_m2_Adjust_Gauge:'//
     &                 'Failed to read input ASCII gauge file'
                  STOP
               endif
            END DO
         END DO
C     
      ELSE IF (csflag .EQ. 'F') THEN
C     
         DO j = 1, 72
            DO i = 1, 144
               READ (inunit, 202, IOSTAT = ios)
     +              gauge(i,j), gaugen(i,j)
               if ( ios .NE. 0 .AND. ios .NE. -1 ) then
                  WRITE(*,*) 'Error in GPCPcdr_m2_Adjust_Gauge:'//
     &                 'Failed to read input ASCII gauge file'
                  STOP
               endif
            END DO
         END DO
C     
      ELSE
C     
         WRITE(*,*) 'Error in GPCPcdr_m2_Adjust_Gauge:'//
     &        'csflag is not M or F'
         STOP
C
      END IF




C     Translate the data to match the GPCC coordinate system.
      DO j = 1, 72
         DO i = 1, 144
            IF  (i .LE. 72) THEN
               tempg(i,j) = gauge(i + 72, j)
               tempgn(i,j) = gaugen(i + 72, j)
            ELSE
               tempg(i,j) = gauge(i - 72, j)
               tempgn(i,j) = gaugen(i - 72, j)
            END IF
         END DO
      END DO
C
      DO i = 1, 144
         DO j = 1, 72
            gauge(i,j) = tempg(i,j)
            gaugen(i,j) = tempgn(i,j)
         END DO
      END DO



c     close file
      close(inunit, IOSTAT=ios)
      if ( ios .NE. 0 ) then
         WRITE(*,*) 'Error in GPCPcdr_m2_Adjust_Gauge:'//
     +      'Failed to close file  ''//fname//'
         STOP
      end if


c     Format statements
 200  FORMAT (A1)
 202  FORMAT (F9.2,15X,F2.0)

      end subroutine Read_GPCCv6_ASCII
