      subroutine Write_Binary_File(fname, data, ilen, jlen)
c     Simple code to write a single field of real*4 data to
c     an unformatted, direct access binary file. This kind 
c     of file is used to store interim GPCP data.  
c
c     Inputs:
c       fname      Name of input file (limited to 256 char)
c       data       output data (size ilen x jlen)
c       ilen       length of first data dimension
c       jlen       length of  second data dimensio

      integer*4     inunit, ilen, jlen
      real*4        data(ilen,jlen)
      logical       opn
      character*256 fname


c     get unused unit number
      inunit = 0
      opn = .TRUE.
      DO WHILE (opn)
         inunit = inunit + 1
         INQUIRE(inunit, OPENED = opn)
      END DO

c     open file
      open(inunit,file=fname, IOSTAT=ios, STATUS="replace",
     &     form='unformatted',access='direct',recl=4*ilen*jlen)
      if ( ios .NE. 0 ) then
         WRITE(*,*) 'Error in '//fname//':'//'Failed to open file'
         STOP
      end if

c     write records tofile
      write(inunit,rec=1, IOSTAT=ios) data
      if ( ios .NE. 0 ) then
         WRITE(*,*) 'Error in '//fname//':'//'Failed to write file'
         STOP
      end if

c     close file
      close(inunit, IOSTAT=ios)
      if ( ios .NE. 0 ) then
         WRITE(*,*) 'Error in '//fname//':'//'Failed to close file'
         STOP
      end if


      end subroutine Write_Binary_File

