c     Code to add 1deg monthly AIRS data into pre-existing annual file
c
c     Original code:
C* Input command-line arguments:				       *
C*								       *
C*   tfilem	CHAR	AIRS monthly file to be added		       *
C*   tfiley	CHAR	AIRS yearly file to be updated		       *
C*   cmonth	CHAR	input month of data			       *

      subroutine GPCPcdr_m2_AIRS_Add(afilem, afiley, cmonth)

      IMPLICITNONE

      INTEGER*4     imonth, l_fm, l_fy
      INTEGER*4     j, k, itounit, itdunit, ios
      INTEGER*4	    idum/259200/
      REAL*4        adata(360,180), tmpdata(360,180)
      CHARACTER*2   cmonth
      CHARACTER*256 afilem, afiley
      LOGICAL       opn



c     Get length of filenames and convert month to integer
      do l_fm = 1,len_trim(afilem)
         if (afilem(l_fm:l_fm) .eq. ' ') then
            continue
         end if
      end do
      l_fm=l_fm-1
      do l_fy = 1,len_trim(afiley)
         if (afiley(l_fy:l_fy) .eq. ' ') then
            continue
         end if
      end do
      l_fy=l_fy-1

      read(cmonth, '(i10)' ) imonth      


C***********************************************************************
C     Retrieve the month of AIRS data to be added to the yearly file.
C     This code was contained in gtairsd1.f, but was too short to
c     justify a separate file

      itounit = 0
      opn = .TRUE.
      
C     Find the next available file unit number for the AIRS data file.
      DO WHILE (opn)
         itounit = itounit + 1
         INQUIRE (itounit, OPENED = opn)
      END DO


C     Open the AIRS data file and read the data
      OPEN (itounit, FILE = afilem, FORM = 'UNFORMATTED', 
     +     ACCESS = 'DIRECT', RECL = 4*64800, IOSTAT = ios)
      if ( ios .NE. 0 ) then
         WRITE(*,*) 'Error in GPCPcdr_m2_AIRS_Add:'//
     &        'Failed to open input AIRS file'
         STOP
      end if

      READ (itounit, REC = 1, IOSTAT = ios) adata
      if ( ios .NE. 0 ) then
         WRITE(*,*) 'Error in GPCPcdr_m2_AIRS_Add:'//
     &        'Failed to read from input AIRS file'
         STOP
      end if
      
      CLOSE (itounit, IOSTAT = ios)
      if ( ios .NE. 0 ) then
         WRITE(*,*) 'Error in GPCPcdr_m2_AIRS_Add:'//
     &        'Failed to close input AIRS file'
         STOP
      end if

C     Rearrange the data to fit the expected incoming XOVER 
C     orientation.
      DO j = 1, 180
         DO k = 1, 360
            IF  (k .LE. 180) THEN
               tmpdata(k,j) = adata(k + 180, 181 - j)
            ELSE
               tmpdata(k,j) = adata(k - 180, 181 - j)
            END IF
         END DO
      END DO
C
      DO j = 1, 180
         DO k = 1, 360
            adata(k,j) = tmpdata(k,j)
         END DO
      END DO



C***********************************************************************
C     Write the month of data to the yearly file.
C     This code was contained in wtdata.f, but was too short to
c     justify a separate file

      itdunit = 0
      opn = .TRUE.
      DO WHILE (opn)
         itdunit = itdunit + 1
         INQUIRE (itdunit, OPENED = opn)
      END DO
      
c     Write to the annual file
      OPEN (itdunit, FILE = afiley, FORM = 'UNFORMATTED', 
     +     ACCESS = 'DIRECT', RECL = 4*64802, IOSTAT = ios)
      if ( ios .NE. 0 ) then
         WRITE(*,*) 'Error in GPCPcdr_m2_AIRS_Add:'//
     &        'Failed to open output AIRS file'
         STOP
      end if

      WRITE (itdunit, REC = imonth) idum, adata, idum
      if ( ios .NE. 0 ) then
         WRITE(*,*) 'Error in GPCPcdr_m2_AIRS_Add:'//
     &        'Failed to write to output AIRS file'
         STOP
      end if
     
      CLOSE (itdunit, IOSTAT = ios)
      if ( ios .NE. 0 ) then
         WRITE(*,*) 'Error in GPCPcdr_m2_AIRS_Add:'//
     &        'Failed to close output AIRS file'
         STOP
      end if




      end subroutine GPCPcdr_m2_AIRS_Add





