#!/bin/sh
#
# Run Airs code for a single month
#
# GPCPcdr_m2_Grid_AIRS_1month.sh 2012 01

yyyy=$1
mm=$2

InputPATH=$(echo `grep "InputPATH" OptionsM.h` | awk -F\"  '{print $2}')
InterimPATH=$(echo `grep "InterimPATH" OptionsM.h` | awk -F\"  '{print $2}')


# create output directory if necessary
indir="${InputPATH}AIRS_V6/${yyyy}/${mm}"
outdir="${InterimPATH}AIRS_V6_1DD/${yyyy}/${mm}/"
if [ ! -d ${InterimPATH}AIRS_V6_1DD/${yyyy} ]; then
    mkdir ${InterimPATH}AIRS_V6_1DD/${yyyy}
fi

if [ ! -d $outdir ]; then
    mkdir $outdir
fi



# scroll through all possible days
for dd in 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31
do
  
  # get day of year; suppress warnings when day of month does not exist
  if ddd=`date -d "${mm}/${dd}/${yyyy}" +%j 2>/dev/null`; then

    if infile=`ls ${indir}/AIRS.${yyyy}.${mm}.${dd}.L2G.Precip_Est.*.hdf`; then
      echo "GPCPcdr_m2/GPCPcdr_m2_Grid_AIRS/GPCPcdr_m2_Grid_AIRS ${infile} ${outdir}"
      GPCPcdr_m2/GPCPcdr_m2_Grid_AIRS/GPCPcdr_m2_Grid_AIRS ${infile} ${outdir}
    fi
  fi
done


