	SUBROUTINE GSDSINFO (isd_id, iindex, isds_id, iedges)
C
C***********************************************************************
C* GSDSINFO  	Extracts necessary info from the specified SDS	       *
C*								       *
C* Called By:	GETL2GFD, GETL2GDD				       *
C*								       *
C* Calls:	HDF Routines					       *
C*  								       *
C* GSDSINFO opens and retrieves the array dimensions of the specified  *
C* SDS.  It also determines and returns the SDS ID.		       *
C*  								       *
C* Input Parameters:						       *
C*								       *
C*  isd_id	INT	HDF file ID				       *
C*  iindex	INT	index number of SDS in the HDF file	       *
C* 								       *
C* Output Parameters:						       *
C*								       *
C*  isds_id	INT	SDS ID					       *
C*  iedges	INT	array of SDS array dimensions		       *
C* 								       *
C**								       *
C* Log:								       *
C* D.Bolvin/SSAI	 9/97	First Version			       *
C* E.Nelkin/SSAI	 8/12	LINUX Version			       *
C***********************************************************************
C
	IMPLICIT	NONE
C
C***********************************************************************
C	Include header file for FORTRAN HDF parameter definitions.
C
C	INCLUDE		"/usr/apps/32/hdf4.1r1/include/hdf.inc"
C	INCLUDE		"/usr/local/hdf4/include/hdf.inc"
C       Changed by Sapiano
C	INCLUDE		"/usr/local/hdf-4.2.6/include/hdf.inc"
	INCLUDE		"hdf.inc"
C
C***********************************************************************
C	Declaration of subroutine input/output arguments.
C
	INTEGER*4	isd_id, iindex, isds_id, iedges(3)
C
C***********************************************************************
C	Declaration of internal subroutine functions and variables.
C
	INTEGER*4	sfselect, sfdimid, sfgdinfo, heprnt
	INTEGER*4	idim_id, istatus, icount1, icount2, itype, iatt,
     +			icount3
C
	CHARACTER	dim_name(256)
C
C***********************************************************************
C	Open the SDS and get the SDS ID.
C
	isds_id = sfselect (isd_id, iindex)
C
	IF  (isds_id .EQ. FAIL) THEN
	    WRITE (*,*) 'ERROR: UNABLE TO OPEN SDS; TERMINATING ',
     +			'EXECUTION; SUBROUTINE GSDSINFO'
	    istatus = heprnt (0)
	    STOP
	END IF
C
C***********************************************************************
C	Get the first dimension of the SDS array.  
C
	idim_id = sfdimid (isds_id, 0)
C
	IF  (idim_id .EQ. FAIL) THEN
	    WRITE (*,*) 'ERROR: UNABLE TO GET FIRST DIMENSION OF SDS ',
     +			'ARRAY; TERMINATING EXECUTION; SUBROUTINE ',
     +			'GSDSINFO'
	    istatus = heprnt (0)
	    STOP
	END IF
C
	istatus = sfgdinfo (idim_id, dim_name, icount1, itype, iatt)
C
	IF  (istatus .EQ. FAIL) THEN
	    WRITE (*,*) 'ERROR: UNABLE TO GET INFO ON FIRST DIMENSION ',
     +			'OF SDS; TERMINATING EXECUTION; SUBROUTINE ',
     +			'GSDSINFO'
	    istatus = heprnt (0)
	    STOP
	END IF
C
C***********************************************************************
C	Get the second dimension of the SDS array.  
C
	idim_id = sfdimid (isds_id, 1)
C
	IF  (idim_id .EQ. FAIL) THEN
	    WRITE (*,*) 'ERROR: UNABLE TO GET SECOND DIMENSION OF ',
     +			'SDS; TERMINATING EXECUTION; SUBROUTINE ',
     +			'GSDSINFO'
	    istatus = heprnt (0)
	    STOP
	END IF
C
	istatus = sfgdinfo (idim_id, dim_name, icount2, itype, iatt)
C
	IF  (istatus .EQ. FAIL) THEN
	    WRITE (*,*) 'ERROR: UNABLE TO GET INFO ON SECOND ',
     +			'DIMENSION OF SDS; TERMINATING EXECUTION; ',
     +			'SUBROUTINE GSDSINFO'
	    istatus = heprnt (0)
	    STOP
	END IF
C
C***********************************************************************
C	Get the third dimension of the SDS array.  
C
	idim_id = sfdimid (isds_id, 2)
C
	IF  (idim_id .EQ. FAIL) THEN
	    WRITE (*,*) 'ERROR: UNABLE TO GET SECOND DIMENSION OF ',
     +			'SDS; TERMINATING EXECUTION; SUBROUTINE ',
     +			'GSDSINFO'
	    istatus = heprnt (0)
	    STOP
	END IF
C
	istatus = sfgdinfo (idim_id, dim_name, icount3, itype, iatt)
C
	IF  (istatus .EQ. FAIL) THEN
	    WRITE (*,*) 'ERROR: UNABLE TO GET INFO ON SECOND ',
     +			'DIMENSION OF SDS; TERMINATING EXECUTION; ',
     +			'SUBROUTINE GSDSINFO'
	    istatus = heprnt (0)
	    STOP
	END IF
C
C***********************************************************************
C	Return the dimensions of the SDS array.  
C
	iedges(1) = icount1
	iedges(2) = icount2
	iedges(3) = icount3
C
	RETURN
	END
