	SUBROUTINE MK_ONAME_1DD ( istime, oname, iret )
C************************************************************************
C* MK_ONAME  Create a local output filename for an AIRS L2G daily accum *
C*									*
C* This subroutine uses the AIRS level 2G precip file name,		*
C* and start and stop times to build a level 2 file name of the form	*
C*   3A_AIRS.V5L2G_1DD.<start_date>.avg                                 *
C* where								*
C*   <start_date> = YYYYMMDD						*
C*									*
C* MK_ONAME  ( itime, oname, iret )					*
C*									*
C* Input parameters:							*
C*   istime	INT4*6	Date/time of orbit start			*
C*									*
C* Output parameters:							*
C*   oname	CHAR*	L.3 AIRS grid file name				*
C*   iret	INT	Return code: 0 = normal				*
C*				    -1 = stop				*
C**									*
C* Log:									*
C* G.Huffman/SSAI	 5/06	Adapt amsu_grid/mk_oname.f		*
C* G.Huffman/SSAI	 2/07	Swap ihour for swathfile, which gave	*
C*				orbit_id in the previous version	*
C* E.Nelkin/SSAI         3/07   Use '3A_AIRS' instead of '3A_airs' for  *
C*                              consistency with previous programs      *
C* E.Nelkin/SSAI         9/07   1-deg daily (1dd) accumulation version  *
C************************************************************************
	IMPLICIT	NONE
	CHARACTER*4	cyyyy
	CHARACTER*2	cmm, cdd
C
	CHARACTER*256	oname
	INTEGER*4	istime (6), iret
C
	iret  = 0
	oname = ' '
C
C	Set '3A_AIRS.V5L2G_1DD.' at start of name (note: a local file).
C	Convert start date to characters and append, with '.avg' suffix.
C
c	if ((istime(1) .EQ. 2013 .AND. istime(2) .LE. 2) .OR.
c     &      (istime(1) .LE. 2012)) THEN
c	   oname (1:18)   = '3A_AIRS.V5L2G_1DD.'
c	else
c	   oname (1:18)   = '3A_AIRS.V6L2G_1DD.'
c	end if

c       All AIRS data is now V6 - change
	print *, "Outputting data with filename: V6"
	oname (1:18)   = '3A_AIRS.V6L2G_1DD.'


	WRITE (cyyyy,  10) istime (1)
   10	FORMAT ( I4.4 )
	WRITE (cmm,    11) istime (2)
   11	FORMAT ( I2.2 )
	WRITE (cdd,    11) istime (3)
	oname (19:30) = cyyyy // cmm // cdd // '.avg'
C
	RETURN
	END
