#include  "xdefines_5deg.h"

      program Main_GPCPcdr_m2_SSMIS_Ocean_Rain_5deg
c     This code takes the histogram file and produces a 
c     rainrate based on lookuptables derived from an RT 
C     model.  The code is based on AAmainRain.F

C     Original code ran with implicit declarations - need to 
c     figure out what each of these variables should be:
      implicit none
      
c     Based on standard rule, all implicit declarations should be real
c     except those starting with letters between i to n. Thus:
      real aa, bfc, RainRate, rr, rr1, rr2, sds
      integer ifill, ilen1, ilen2, minsamps, moday, ntot
      integer*4 strlen, Ninputs
      character*256 HistFile, LandMaskFile, OutFile, InterimPATH
      integer*2  jdata(BIN), iyear, imonth,jbcol,jecol,jbrow,jerow,jchan
      integer*2  icol, irow, i,j, ii, npass
      integer*4  jrecno, jrec_ofset, tmpint
      real*8 table(TBL),fl(COLS,ROWS), thist(BIN),rdata(BIN)
      real*8 StepRatio(8), TotalRain, RainTotal,chi
      character*2    cmonth
      character*3    sat, DayOrNit
      character*4    cyear
      character*256  dsnHist, dsnLandMask, BegDate*24, EndDate*24
      character*128 version*24
      integer*2  kdata(BIN)
      integer    kflag(COLS,ROWS), lun_hist
      real       rlon(COLS), rlat(ROWS)
      integer*2  lbump,jmax
      real       rmap(COLS,ROWS), savr, rmiss, drate
      integer    hsum(COLS,ROWS)

c     *** This array is set by subr. freeze.  .true. means the square
c     *** has less than MinSamps of observations or is land.
      logical*1  NullGrid(COLS,ROWS)

      logical*1  LandMask(COLS,ROWS), LandMasktmp(COLS,ROWS)
      common /land/ LandMask

      real*8       rz,prob,SigmaZero,tzero,SigmaRain,rzero,cutoff,
     &  NumConv,FreezingLevel,htave,m1,m2,m3,pm1,pm2,pm3,hmax,htotal
      common /var/ rz,prob,SigmaZero,tzero,SigmaRain,rzero,cutoff,
     &  NumConv,FreezingLevel,htave,m1,m2,m3,pm1,pm2,pm3,hmax,htotal

      common /rhist/rr(64)
      common /rmiss/rmiss
      common /minim/MinSamps
      common /day_mo/moday(12)
      data moday/ 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/
      data  rmiss/-999.0/
      data  aa / -1./ ifill/-1/
      data version /'Revision: 3.6'/

      data StepRatio/1.15,0.85,1.1,0.95,1.02,0.99,1.005,0.999/
      data lun_hist /10/

      character*128 rcs
      data rcs /'GPCP CDR METH RainRates'/


c     Set some variables that are used for the rain rate calculation:
c     Channel 8 = PC1 ( = 2*v19 - v22); Channel 9 = RainRate
      data jchan /8/
c     Beginning column number
      data jbcol /1/
c     Ending column number
      data jecol /72/
c     Beginning row number
      data jbrow /1/
c     Ending row number
      data jerow /20/ 


c     ******************************************************
c     Setup and checks
      
c     Check the correct number of inputs were given
      Ninputs = iargc()
      if ( Ninputs .NE. 5 ) then
         WRITE(*,*) 'Error in Main_GPCPcdr_m2_SSMIS_Ocean_Rain_5deg:'//
     &        ' Incorrect number of input arguments (should be 5)'
         STOP
      endif

C     Get arguments and set the length of the month in hours.
      call getarg(1, cyear)
      call getarg(2, cmonth)
      call getarg(3, sat)
      call getarg(4, DayOrNit)
      call getarg(5, InterimPATH)

c     Convert month and year to numbers
      read(cyear, '(i10)' ) iyear
      read(cmonth, '(i10)' ) imonth


c     Establish offset record number:
c     5.0 degree histogram contains separate histograms for asc and des.
c     Asc=Nit, des=Day except for F08 where these are opposite
      if (sat == 'F08') then
         if (DayOrNit == 'Day') then
            jrec_ofset=1
         else
            jrec_ofset=COLS*ROWS*9 + 1
         end if
      else
         if (DayOrNit == 'Day') then
            jrec_ofset=COLS*ROWS*9 + 1
         else
            jrec_ofset=1
         end if
      end if



c     Establish filenames
      do strlen = 1,len_trim(InterimPATH)
         if (InterimPATH(strlen:strlen) .eq. ' ') then
            continue
         end if
      end do
      strlen=strlen-1

      dsnHist=InterimPATH(1:strlen)//"/METH_Hist_5deg/"//sat//"Y"//
     &     cyear(3:4)//"M"//cmonth//"_5.0deg_hist_v6"
      dsnLandMask="GPCPcdr_m2/GPCPcdr_m2_SSMIS_Ocean/"//
     &     "GPCPcdr_m2_SSMIS_Ocean_Rain_5deg/mask5.0_50_97-04-25_Gao"
      OutFile=InterimPATH(1:strlen)//"/METH_Rain_5deg/"//sat//"Y"//
     &     cyear(3:4)//"M"//cmonth//DayOrNit//"_5.0deg_rain_v6"

c     *********************************************************
c     Initializations

c     Open output file and write a header
      open(16, file = OutFile)

c     Set the minimum number of samples for calculation.
      MinSamps = 1000

c     Initialize rmap
      do j = 1,  ROWS
        do i = 1, COLS
          rmap(i,j) = rmiss
        enddo
      enddo

c     Mid points of rain rate histogram
c     The first bin of the rr hist is 0 instead of 0.25. 7/7/97
      rr1 = 0.25
      rr(1) = 0.
      rr(2) = 0.125
      do i = 3, 64
        rr2 = rr1 * 1.1
        rr(i) = 0.5 * (rr1 + rr2)
        rr1 = rr2
      enddo

c     Calculate lat and lon
      do j = 1, ROWS
        rlat(j) = TOPLAT - (j - 1) * RES
      enddo
      do i = 1, COLS
        rlon(i) = BEGLON + (i - 1) * RES
        if(rlon(i) .ge. 180.) rlon(i) = rlon(i) - 360.
       enddo

      call fdate(BegDate)

      ilen1 = lnblnk(dsnHist)
      ilen2 = lnblnk(version)
      write(16,'(a,i2,a,i2,a,i1,a,2i4,a,2i3,a,a,a,a, 1x,a)')
     &  'Year:',mod(iyear,100), ' Month:',imonth, 
     &  ' Chan:',jchan, ' Cols:',jbcol,jecol,
     &  ' Rows:',jbrow,jerow,' Input:',dsnHist(:ilen1),
     &  '\tMade:',BegDate(5:), version(:ilen2)

      if((mod(iyear,4) .eq. 0 .and. mod(iyear,100) .ne. 0) .or.
     &  mod(iyear,400) .eq. 0) moday(2) = 29

c     Setup erf distribution table.
      call setuperf(table)

c     Read in the 2.5-degree land mask.  No calculations will be done
c     over land.
      open(unit=9, file=dsnLandMask, access='direct', recl=ROWS*COLS,
     &  form='unformatted',  status='old', err=930)
      read(9,rec=1,err=940) LandMask
      close(unit=9)


c     Open histogram and use it in the followings without closing
      open(unit=lun_hist,file=dsnHist,access='direct',recl=390,
     &  form='unformatted', status='old', err=950)



      call freeze(lun_hist, fl, NullGrid, jrec_ofset, jbcol,jecol,
     &  jbrow,jerow,hsum)

c     Process one grid at a time
      do 400 irow=jbrow,jerow

        do 300 icol=jbcol,jecol

c     Skip processing of this square if it has less than
c     the minimum number of observations or is over land..
          if(LandMask(icol,irow)) go to 300

          TotalRain = rmiss

          if( NullGrid(icol,irow) ) go to 200
          
c     Read channel 'jchan' only.  (9 chans per square.)
          jrecno = jrec_ofset + (((icol-1) * ROWS) 
     &         + (irow-1))*CHANS+jchan
          read(lun_hist, rec=jrecno, err=960) jdata

c     Remove the left side bumps
          call qchist(jdata,kdata,lbump,jmax)
          kflag(icol,irow) = 0
          if(NullGrid(icol,irow)) kflag(icol,irow) = 1
          if(lbump .gt. 0) kflag(icol,irow) = 2
          if(.not. NullGrid(icol,irow) .and. lbump .eq. 0 )
     &           kflag(icol,irow) = 4


c     Changed by Jie Meng 7/95.  (Was jdata instead of kdata.)
          do j=1,BIN,5
            rdata(j+0) = kdata(j+0)
            rdata(j+1) = kdata(j+1)
            rdata(j+2) = kdata(j+2)
            rdata(j+3) = kdata(j+3)
            rdata(j+4) = kdata(j+4)
          enddo

c     Initialize variables.
          FreezingLevel = 4.0
          if( fl(icol,irow) .gt. 0.0 ) FreezingLevel = fl(icol,irow)

          if( jchan .eq. 8 ) then
            cutoff = 0.5
          else
            cutoff = 1.5
          endif

          pm3       = 0.0
          prob      = 0.0
          rz        = 0.0
          chi       = 0.0
          SigmaZero = 0.0
          tzero     = 0.0
          SigmaRain = 1.0
          rzero     = 1.0
          NumConv   = 1.0
          npass     = 1

c     Get moments now.
          call GetMoments(rdata)

c     m2 SSM/I values are generally ~10-19 (and range at least 5-38).
          if (m2 .gt. 1000. ) goto 200
          if (m3 .gt. 50000. ) goto 200
          if (htotal .lt. MinSamps ) goto 200

          tzero = htave

c     Repeat calculation.
          i = 0
 30       if (rzero .gt. 19.) npass = npass + 1
          if (npass .gt. 8  ) npass = 8

          if (prob .gt. 0.8 .and. npass .lt. 5 ) then
            SigmaRain = SigmaRain * 0.95
            rzero     = rzero/0.85
            SigmaZero = SigmaZero + 0.5
          endif

          rz = rzero

          call HistMoment(jchan,table,rdata,thist)

          i = i + 1
          if(StepRatio(npass) .gt. 1. .and. pm3 .gt. m3) npass = npass+1
          if( npass.gt.8 ) npass = 8
          if(StepRatio(npass) .lt. 1. .and. pm3 .lt. m3) npass = npass+1
          if ( npass .gt. 8 ) npass = 8
          rzero = rzero*StepRatio(npass)

          if ( rzero .gt. 20. ) then
            rzero = 20.
          else if ( rzero .lt. 0.1 ) then
            npass = 8
          endif

          if ( i .gt. 60 .or. npass .ge.8 ) go to 40
          go to 30
 40       continue

c     Chi test now.
          call ChiTest(chi,thist,rdata)

c     beam filling correction is freezing level dependent now. 7/7/97
          bfc = 0.44 * fl(icol,irow) / 5.0 + 1.0

c     Compute rain from "Channel 8" (PC1) histogram.
          TotalRain = RainTotal(prob,rz,SigmaRain,cutoff,
     &                            table,imonth) * bfc

c     Filter and fill

 200      continue
          if (TotalRain .ge. 0.) rmap(icol,irow) = TotalRain



c     Sapiano, Sep 2013
c     Value for chi square test is different for SSMIS than for SSMI
c     Many different values were tried for METH SSMIS code, threshold used
c     is 15000 as modified by Y.-J. Cho on 05/12/2011
c          if(chi .gt. 15000. .or. rzero .gt.15. .or. 
c     &         hsum(icol,irow).lt.MinSamps) then 
c
c     Sapiano, Nov 2014
c     Chisq threshold changed when Tzero offset was removed.
          if(chi .gt. 5*5000. .or. rzero .gt.15. .or.  
     &              hsum(icol,irow).lt.MinSamps) then 

             
             jrecno = jrec_ofset + (((icol-1) * ROWS)+(irow-1))*CHANS+9
            read (lun_hist, rec=jrecno, err=960) jdata
            call hist_avrg(jdata,ntot,savr,sds)
            if (ntot .gt. 100) then
              rmap(icol,irow) = savr * moday(imonth) * 24.
              kflag(icol,irow) = 64
              htotal = hsum(icol,irow)
            endif
          endif

          RainRate = rmap(icol,irow)
          drate = RainRate / moday(imonth)

          if(rmap(icol,irow) .ge. 0. .and. kflag(icol,irow) 
     &                  .lt. 64) then
           write(16,'(i2,i4,1x,f9.1,1x,f8.2,5f6.2,3f8.2,f9.2,i6,
     &    f6.2,f8.2,1x,f9.2,
     &     2f6.2,i5,i3,f6.1,f7.1)', err=980)
     &     irow,icol,chi,RainRate,prob,rzero,SigmaRain,cutoff,
     &     SigmaZero,tzero,pm1,pm2,pm3,int(htotal),m1,m2,m3,
     &     FreezingLevel,drate,jmax,kflag(icol,irow),rlat(irow),
     &     rlon(icol)

          else if(rmap(icol,irow) .ge. 0. .and. kflag(icol,
     &            irow) .eq. 64)then

            if( ntot .lt. MinSamps ) FreezingLevel = aa
            htotal = ntot

            write(16,'(i2,i4,1x,f9.1,1x,f8.2,5f6.2,3f8.2,f9.2,i6,
     &        f6.2,f8.2,1x,f9.2,
     &        2f6.2,i5,i3,f6.1,f7.1)', err=980)
     &        irow,icol,aa,RainRate,aa,aa,aa,aa,aa,aa,aa,aa,aa,
     &        int(htotal),aa,aa,
     &        aa,FreezingLevel,drate,ifill,kflag(icol,irow),
     &        rlat(irow),rlon(icol)

          endif

 300    continue

 400  continue

c     Check to see that the erf table was not changed.
      call check_erf(table)

      close(unit=lun_hist)

c     Signal the end of the RAINYY program output.
      write(16,'(A149)',err=980) "99 999       0.0     0.00"//
     &     "  0.00  0.00  0.00  0.00  0.00    0.00    0.00"//
     &     "    0.00     0.00     0  0.00    0.00      0.00  "//
     &     "0.00  0.00    0  0   0.0    0.0"
      write(16,'(A56)',err=980) "========================="//
     &     "====================================="

c     Output file also includes some information on the files 
c     that were included in the compilation.  This is excluded 
c     here since it is not actually useful
      close(16)




      call fdate(EndDate)

      write(0,*)'Program began execution at: ', BegDate
      write(0,*)'Program ended execution at: ', EndDate

      stop '*** program finished successfully ***'


 930  call perror('Open ERROR for land mask')
      call exit(1)

 940  call perror('Read ERROR for land mask')
      call exit(1)

 950  call perror('main: Open ERROR for input histogram')
      call exit(1)

 960  call perror('main: Read ERROR for input histogram')
      write(0,*)'icol,irow,jrecno:', icol,irow,jrecno
      call exit(1)
 980  call perror('main: ERROR in writing ASCII file')
      call exit(1)


      end program Main_GPCPcdr_m2_SSMIS_Ocean_Rain_5deg










