c $Header: /home/powell/tasks/sun0230/rain_25_50/RCS/avrg_hist.F,v 1.1 1996/12/16 16:40:49 powell Exp $

c $Log: avrg_hist.F,v $
c Revision 1.1  1996/12/16 16:40:49  powell
c Initial revision
c

      subroutine avrg_hist(lun_hist,imonth,jbcol,jecol,jbrow,
     &  jerow,jrec_ofset,savr,ntot)

#include  "xdefines_5deg.h"

c *** The subroutine is used to fill gaps in the rainyy output.
c     Read instantaneous rain rate histogram, which is the 9th channel in the
c     ssmi Tb histogram, and compute the simple average.
c     Output: savr -- simple average (mm/mo)

      integer*2  jdata(BIN), imonth,jbcol,jecol,jbrow,jerow,jchan
      integer*2  icol, irow, i,j
      integer*4  jrecno, jrec_ofset, lun_hist
      real       savr(COLS,ROWS)
      integer    ntot, mohr
      real       avr, rr1, rr2, tmp1, tmp2

      logical*1  LandMask(COLS,ROWS)
      common/land/ LandMask
      common /rhist/rr(64)
      common /day_mo/moday(12)
      common /rmiss/rmiss

      character*128 rcs
      data rcs/'Id: avrg_hist.F,v 1.1 1996/12/16 16:40:49 powell Exp '/

C EJN: The 9 channels represent v19, h19, v22, v37, h37, v85 (actually
C v92 for SSMIS), h85 (actually h92 for SSMIS), PC1 ( = 2*v19 - v22),
C and RainRate.
 
      jchan = 9

c *** Initialize monthly rain rate
      do j = 1, ROWS
      do i = 1, COLS
	savr(i,j) = rmiss
      enddo
      enddo

c *** Mid points of rain rate histogram
      rr1 = 0.25
      rr(1) = 0.
      do i = 2, 64
        rr2 = rr1 * 1.1
	tmp1 = alog(rr1)
	tmp2 = alog(rr2)
	rr(i) = exp(0.5 * (tmp1 + tmp2))
	rr1 = rr2
      enddo

      mohr = moday(imonth) * 24.

      do 400 irow = jbrow, jerow

        do 300 icol = jbcol, jecol
	  avr = 0.

          if( LandMask(icol,irow) ) goto 300

c *** Read channel 'jchan' only.  (9 chans per square.)

          jrecno = jrec_ofset + (((icol-1) * ROWS) + (irow-1))*CHANS+
     &                          jchan
          read(lun_hist, rec=jrecno, err=960) jdata

          call hist_avrg (jdata,ntot,avr,sds)

          if (ntot .gt. 100) then
	    savr(icol,irow) = avr * mohr
          endif

300     continue
400   continue
      return

960   call perror('avrg_his: Read ERROR for input histogram')
      write(0,*)'icol,irow,jrecno:', icol,irow,jrecno
      return
      end
