c $Header: /home/ssmi/process/rain_25_50/histmoment.F v1.2 2008/05/27 17:05:16 roongroj $

c $Log: histmoment.F,v $
c Revision 1.2  2008/05/27 17:05:16 roongroj 
c
c Revision 1.1  1996/12/13 19:42:29 powell
c Initial revision
c

      subroutine HistMoment(jchan,table,rdata,thist)

#include "xdefines_5deg.h"

      real*8 rdata(BIN),nrnorm,phtotal
      real*8 rhist(BIN),nrhist(BIN),thist(BIN),table(TBL), r0
      real*8 rr, tb, rnorm, rm2, x, fac2, y, dtz, fac
      integer*2 jpass, jchan, ii, jj
      integer*4 nint

      real*8      rz,prob,SigmaZero,tzero,SigmaRain,rzero,cutoff,
     #  NumConv,FreezingLevel,htave,m1,m2,m3,pm1,pm2,pm3,hmax,htotal
      common/var/ rz,prob,SigmaZero,tzero,SigmaRain,rzero,cutoff,
     #  NumConv,FreezingLevel,htave,m1,m2,m3,pm1,pm2,pm3,hmax,htotal

      character*128 rcs
      data rcs/'Id: histmoment.F v1.2 2008/05/27 17:05:16 roongroj '/

      call NoRainHist(nrhist)

      r0 = 25.0/(FreezingLevel**1.2)
c     Channel 9 of histogram is no longer for 2*37-22 Tb,
c     instead is histogram of instantaneous rain rate.  The following
c     statement is obsolete now.   11/14/96, JM
c     if ( jchan .eq. CHANS ) r0 = r0 / 4.0

      do 10 ii = 1,BIN,5
      rhist(ii+0) = 0.0
      rhist(ii+1) = 0.0
      rhist(ii+2) = 0.0
      rhist(ii+3) = 0.0
10    rhist(ii+4) = 0.0

      do 20 ii = 1,TBL
      rr = rzero * dexp( SigmaRain*table(ii) )
      tb = tzero + (285.-tzero) * (1.-dexp(-rr/r0)) - 3.5*dsqrt(rr)
      jj = nint(tb) - LTB

      if ( jj .lt. 3 ) then
         jj = 3
      else if ( jj .gt. 193 ) then
         jj = 193
      endif

      rhist(jj-1) = rhist(jj-1) + 1
      rhist(jj)   = rhist(jj) + 1
      rhist(jj+1) = rhist(jj+1) + 1
      rhist(jj+2) = rhist(jj+2) + 1
      rhist(jj-2) = rhist(jj-2) + 1
20    continue


c *** calc norms for both rain and no rain parts & 1st, 2nd moments
      rnorm 	= 0.0
      nrnorm	= 0.0
      rm2       = 0.0

      do 30 ii=10,185,5
      x		= (ii+0) + LTB - htave
      rm2       = rm2 + x*(x*rhist((ii+0)))
      rnorm	=  rnorm +  rhist((ii+0))
      nrnorm	= nrnorm + nrhist((ii+0))
      x         = (ii+1) + LTB - htave
      rm2       = rm2 + x*(x*rhist((ii+1)))
      rnorm	=  rnorm +  rhist((ii+1))
      nrnorm	= nrnorm + nrhist((ii+1))
      x         = (ii+2) + LTB - htave
      rm2       = rm2 + x*(x*rhist((ii+2)))
      rnorm	=  rnorm +  rhist((ii+2))
      nrnorm	= nrnorm + nrhist((ii+2))
      x         = (ii+3) + LTB - htave
      rm2       = rm2 + x*(x*rhist((ii+3)))
      rnorm	=  rnorm +  rhist((ii+3))
      nrnorm	= nrnorm + nrhist((ii+3))
      x         = (ii+4) + LTB - htave
      rm2       = rm2 + x*(x*rhist((ii+4)))
      rnorm	=  rnorm +  rhist((ii+4))
30    nrnorm	= nrnorm + nrhist((ii+4))

      rm2 = rm2/rnorm

c *** calc prob of rain using variances and re-fitted tzero
      x     = NumConv * SigmaZero**2 + (tzero-htave)**2
      prob  = (NumConv*m2 - x) / (rm2-x)
      jpass = 1

40    if (jpass .gt. 1 ) prob = prob * m2/pm2

      if( prob .gt. 0.999 ) then
         prob  = 0.999
         rzero = rzero * 1.1
      endif

c      prob = amax1( prob, 0.0 )
      prob = max( prob, 0.0 )

      fac  = prob * htotal / rnorm
      fac2 = (1.0-prob) * htotal / nrnorm

      do 50 ii=10,185,5
      thist(ii+0) = fac * rhist(ii+0) + fac2 * nrhist(ii+0)
      thist(ii+1) = fac * rhist(ii+1) + fac2 * nrhist(ii+1)
      thist(ii+2) = fac * rhist(ii+2) + fac2 * nrhist(ii+2)
      thist(ii+3) = fac * rhist(ii+3) + fac2 * nrhist(ii+3)
50    thist(ii+4) = fac * rhist(ii+4) + fac2 * nrhist(ii+4)

      pm1     = 0.0
      pm2     = 0.0
      pm3     = 0.0
      phtotal = 0.0

      do 60 ii=10,185,5
      x          = thist((ii+0))
      y          = (ii+0) - htave + LTB
      pm1     = pm1 +  (x*y)
      pm2     = pm2 + ((x*y)*y)
      pm3     = pm3 + ((x*y)*y)*y
      phtotal = phtotal + x
      x          = thist((ii+1))
      y          = (ii+1) - htave + LTB
      pm1     = pm1 +  (x*y)
      pm2     = pm2 + ((x*y)*y)
      pm3     = pm3 + ((x*y)*y)*y
      phtotal = phtotal + x
      x          = thist((ii+2))
      y          = (ii+2) - htave + LTB
      pm1     = pm1 +  (x*y)
      pm2     = pm2 + ((x*y)*y)
      pm3     = pm3 + ((x*y)*y)*y
      phtotal = phtotal + x
      x          = thist((ii+3))
      y          = (ii+3) - htave + LTB
      pm1     = pm1 +  (x*y)
      pm2     = pm2 + ((x*y)*y)
      pm3     = pm3 + ((x*y)*y)*y
      phtotal = phtotal + x
      x          = thist((ii+4))
      y          = (ii+4) - htave + LTB
      pm1     = pm1 +  (x*y)
      pm2     = pm2 + ((x*y)*y)
      pm3     = pm3 + ((x*y)*y)*y
60    phtotal = phtotal + x

      pm1 = pm1 / phtotal
      pm2 = pm2 / phtotal
      pm3 = pm3 / phtotal
      pm3 = pm3 - 3. * pm1*pm2 + 2. * pm1*pm1*pm1

      jpass = jpass + 1

      if( ((pm2-m2)/m2)**2 .lt. 0.0001 .or. jpass .gt. 10
     #       .or. prob .gt. 0.99 .or. prob .lt. 0.0001 ) go to 70
      go to 40
70    continue

      ii = nint( tzero - real(LTB) - 3.0*SigmaZero )
      if (ii .lt. 1) ii = 1

      if( prob .lt. 0.5 .and. (thist(ii)-rdata(ii)) .gt. 1.0 .and.
     #            SigmaZero .gt. 0.5 )   SigmaZero = SigmaZero*0.9

      if( rdata(ii)-thist(ii) .gt. 1.0 ) SigmaZero = SigmaZero+0.1

      dtz = - pm1

      if( dtz .gt. 1.) then
         dtz = 1.0
      else if( dtz .lt. -1.) then
         dtz = -1.0
      endif

      tzero = tzero + dtz  

      if (tzero .lt. 110.0 ) then
         tzero = 110.0
      else if (tzero .gt. 250.0 ) then
         tzero = 250.0
      endif

      return
      end

