c $Header: /home/ssmi/process/rain_25_50/freeze.F v1.4 2008/05/26 18:50:11 roongroj $

c $Log: freeze.F,v $
c Revision 1.5  2011/02/14 16:35:00 nelkin
c Add comment
c
c Revision 1.4  2008/05/26 18:50:11 roongroj
c
c Revision 1.3  1997/12/06 23:13:51 powell
c Reverting back to earlier version.  Requested by Jie Meng 12/06/97.
c
c Revision 1.1  1996/12/13 19:42:26 powell
c Initial revision
c Revision 1.2  1997/04/16 17:42:26 meng  
c    ksum is set to array hsum(COLS,ROWS).

c Need landmask for 5 deg.  12/6/96

      subroutine freeze
     # (lun_hist,fl,NullGrid,jrec_ofset,jbcol,jecol,jbrow,jerow,hsum)

#include "xdefines.h"
c#include "f77_floatingpoint.h"

c *** This subroutine reads the histogram on disk instead of tape.

      real*8 fl(COLS,ROWS), pct, rr
      integer*2 jbcol, jecol, jbrow, jerow, icol, irow, j, tb22, tb19
      integer*4 jrecno, jrecch3, ksum, jrec_ofset, lun_hist

      logical*1  NullGrid(COLS,ROWS)

      integer*2         jdata1, jdata2
      common/jdata/     jdata1(BIN), jdata2(BIN)

      logical*1  LandMask(COLS,ROWS)
      common/land/ LandMask

      integer hsum(COLS,ROWS)

      character*128 rcs
      data rcs/'$Id: freeze.F v1.4 2008/05/26 18:50:11 roongroj $'/

      do 200 irow = jbrow,jerow

      do 190 icol = jbcol,jecol

c *** Assume that all squares have less than minimum observations.
c *** (Also true if over land.)
      NullGrid(icol,irow) = .true.
c      write(0,*) 'icol, irow :', icol, irow

c *** Skip if this grid is over land.

      if(LandMask(icol,irow)) go to 190


c *** Read channel 1.
      jrecno = jrec_ofset + (((icol-1) * ROWS) + (irow-1)) * CHANS + 1  
      read(lun_hist, rec=jrecno, err=930) jdata1      
c *** Sum up channel 1 to see if we have enough observations.
      ksum = 0
      do 50 j=1,BIN,5
      ksum = ksum + jdata1(j+0)
      ksum = ksum + jdata1(j+1)
      ksum = ksum + jdata1(j+2)
      ksum = ksum + jdata1(j+3)
50    ksum = ksum + jdata1(j+4)
      
      hsum(icol,irow) = ksum

c *** If we have enough observations, then get chan 3 and call subs.
c NOTE: jdata1 treated as 2-D in GetPctile, so it uses common org. to
c get BOTH 19 and 22 GHz.

      if( ksum .gt. 1000 ) then
         NullGrid(icol,irow) = .false.
         jrecch3 = jrecno+2
         read(10, rec=jrecch3, err=940) jdata2
         call GetPctile(pct,tb22,tb19,jdata1)
         call fit(tb19,tb22,rr,fl(icol,irow))
      endif
c      write(0,*) 'icol,irow,NullGrid:',icol,irow,NullGrid(icol,irow)
190   continue
200   continue      
      return

930   call perror( 'freeze: Chan one error' )
      write(0,*) 'icol, irow, jrecno:', icol, irow, jrecno
      call exit(97)

940   call perror( 'freeze: Chan three error' )
      write(0,*) 'jrecch3:', jrecch3
      call exit(98)

      end
