      subroutine Read_Binary_File (fname, ilen, jlen, fieldnum, data)
c     Simple code to read real*4 data from an unfomratted, 
c     direct access binary file. This kind of file is used 
c     to store interim GPCP data.  There is an optin to read
c     a field of a multi-field file (ie: a file with multiple
c     ilen*jlen fields )
c
c     Inputs:
c       fname      Name of input file (limited to 256 char)
c       ilen       length of first data dimension
c       jlen       length of  second data dimensio
c       fieldnum   read a particular ilen*jlen field
c
c     Outputs
c       data       output data (size ilen x jlen)

      integer*4     inunit, ilen, jlen, fieldnum, recnum
      real*4        data(ilen,jlen)
      logical       opn
      character*256 fname


c     get unused unit number
      inunit = 0
      opn = .TRUE.
      DO WHILE (opn)
         inunit = inunit + 1
         INQUIRE(inunit, OPENED = opn)
      END DO

c     open file
      open(inunit,file=fname, IOSTAT=ios,
     &     form='unformatted',access='direct',recl=4*ilen,status='old')
      if ( ios .NE. 0 ) then
         WRITE(*,*) 'Error in '//fname//':'//'Failed to open file'
         STOP
      end if

c     read records from file
      do j = 1, jlen
         recnum=j+(fieldnum-1)*jlen
         read(inunit,rec=recnum, IOSTAT=ios) (data(i,j), i=1,ilen)
         if ( ios .NE. 0 ) then
            WRITE(*,*) 'Error in '//fname//':'//'Failed to read file'
            STOP
         end if
      end do

c     close file
      close(inunit, IOSTAT=ios)
      if ( ios .NE. 0 ) then
         WRITE(*,*) 'Error in '//fname//':'//'Failed to close file'
         STOP
      end if

      end subroutine Read_Binary_File



