	SUBROUTINE CZONAVG (arrin1, arrin2, arrout1, arrout2)
C
C***********************************************************************
C* CZONAVG  	Compute zonal averages of precipitation fields using   *
C*		only coincident grid boxes			       *
C*								       *
C* Called by:	XOVER						       *
C*   								       *
C* Calls:	<none>						       *
C*  								       *
C* CZONAVG computes the zonal averages for two input fields using      *
C* only coincident grid boxes.					       *
C*								       *
C* Input Parameters:						       *
C*								       *
C*  arrin1	REAL	first array containing the month of            *
C*			precipitation data			       *
C*  arrin2	REAL	second array containing the month of           *
C*			precipitation data			       *
C* 								       *
C* Output Parameters:						       *
C*								       *
C*  arrout1	REAL	first array containing the zonal averages of   *
C*			precipitation				       *
C*  arrout2	REAL	second array containing the zonal averages of  *
C*			precipitation				       *
C* 								       *
C**								       *
C* Log:								       *
C* D.Bolvin/SSAI	 8/97	First Version			       *
C***********************************************************************
C
	IMPLICIT	NONE
C
	INTEGER*4	i, j, icount
C
	REAL*4		arrin1(144,72), arrin2(144,72), arrout1(72), 
     +			arrout2(72), FILLCHK/-0.5/, FILL/-9999.9/
C
C***********************************************************************
C	Compute the zonal averages.
C
	DO j = 1, 72
	    icount = 0
	    arrout1(j) = 0.0
	    arrout2(j) = 0.0
	    DO i = 1, 144
	    	IF  ((arrin1(i,j) .GT. FILLCHK) .AND.
     +		     (arrin2(i,j) .GT. FILLCHK)) THEN
	    	    icount = icount + 1
	    	    arrout1(j) = arrout1(j) + arrin1(i,j)
	    	    arrout2(j) = arrout2(j) + arrin2(i,j)
	    	END IF
	    END DO
	    IF  (icount .GT. 0) THEN
	    	arrout1(j) = arrout1(j) / FLOAT (icount)
	    	arrout2(j) = arrout2(j) / FLOAT (icount)
	    ELSE
	    	arrout1(j) = FILL
	    	arrout2(j) = FILL
	    END IF
	END DO
C
	RETURN
	END
