	SUBROUTINE G1TO2P5 (tmpdata, undf, tovsdata)
C
C***********************************************************************
C* G1TO2P5  	Regrids the TOVS data from 1 degree to 2.5 degrees     *
C*								       *
C* Called by:	GETTOVSD					       *
C*   								       *
C* Calls:	<none>						       *
C*  								       *
C* G1TO2P5 regrids the TOVS data from the 1 degree by 1 degree 	       *
C* resolution to the 2.5 degree by 2.5 degree resolution.	       *
C*  								       *
C* Input Parameters:						       *
C*								       *
C*  tmpdata	REAL	array of TOVS data at 1 degree resolution      *
C*  undf	REAL	data fill value				       *
C* 								       *
C* Output Parameters:						       *
C*								       *
C*  tovsdata	REAL	array of TOVS data at 2.5 degree resolution    *
C* 								       *
C**								       *
C* Log:								       *
C* D.Bolvin/SSAI	 8/96	Modified version of routine obtained   *
C*				Paul Piriano			       *
C***********************************************************************
C
	IMPLICIT	NONE
C
	INTEGER*4	i, j, ii, iip1, iip2, intu, jj, jjp1, jjp2
C
	REAL*4		undf, a1, a2, a3, w1, w2, w3, wsum, 
     +			FILL/-9999.9/
C
      	REAL*4		tmpdata(360,180), atmp(144,180), 
     +			tovsdata(144,72)                
C
      	DO j = 1, 180
            DO i = 1, 144
            	ii = INT ((i * 2.5) - 1.5)
            	iip1 = ii + 1
            	iip2 = ii + 2
            	a1 = tmpdata(ii,j)
            	a2 = tmpdata(iip1,j)
            	a3 = tmpdata(iip2,j)
            	intu = MOD (i,2)
		IF  (intu .EQ. 1) THEN
               	    w1 = 2
                    w2 = 2
                    w3 = 1
            	ELSE
                    w1 = 1
                    w2 = 2
                    w3 = 2
            	END IF
            	IF  (a1 .LE. undf) w1 = 0.0
            	IF  (a2 .LE. undf) w2 = 0.0
            	IF  (a3 .LE. undf) w3 = 0.0
            	wsum = w1 + w2 + w3
            	IF  (wsum .GT. 1) THEN
               	    atmp(i,j) = (a1 * w1 + a2 * w2 + a3 * w3) / wsum
            	ELSE
               	    atmp(i,j) = undf
            	END IF
             END DO
     	END DO  
C 
      	DO i = 1, 144
            DO j = 1, 72 
            	jj = INT ((j * 2.5) - 1.5)
            	jjp1 = jj + 1
            	jjp2 = jj + 2
            	a1 = atmp(i,jj)
            	a2 = atmp(i,jjp1)
            	a3 = atmp(i,jjp2)
            	intu = MOD (j,2)
            	IF  (intu .EQ. 1) THEN
                    w1 = 2
                    w2 = 2
                    w3 = 1
           	ELSE
                    w1 = 1
                    w2 = 2
                    w3 = 2
            	END IF
            	IF  (a1 .LE. undf) w1 = 0.0
            	IF  (a2 .LE. undf) w2 = 0.0
            	IF  (a3 .LE. undf) w3 = 0.0
            	wsum = w1 + w2 + w3
            	IF  (wsum .GT. 1) THEN
               	    tovsdata(i,j) = (a1 * w1 + a2 * w2 + a3 * w3) / wsum
            	ELSE
               	    tovsdata(i,j) = FILL
            	END IF
            END DO
      	END DO  
C           
      	RETURN                                                      
      	END                                                            
