C************************************************************************
C* param_.5.h  Include file for .5 deg resolution geometry		*
C*									*
C* This include file sets parameters for the .5 deg resolution		*
C* geometry in program binner.					  	*
C**									*
C* Log:									*
C* G.Huffman/USRA	 9/91	Pulled out of binner.f			*
C* G.Huffman/USRA	10/91	Add PERIOD				*
C* G.Huffman/USRA	11/91	Add MAXED, dflt6			*
C* G.Huffman/USRA	12/91	Add HI, LO; update IVERSN		*
C* G.Huffman/USRA	 1/92	Split up param.h			*
C* G.Huffman/USRA	 4/92	Version 4 for binning surface type,	*
C*				MXSTAT=20				*
C* G.Huffman/USRA	10/92	V.5 includes t86v			*
C* G.Huffman/SSAI	11/93	Change version numbering		*
C************************************************************************
	REAL		RMISS,  DLAT,   DLONC,  DLONNS, BNDRY
	INTEGER		IVERSB, IVERSH, IVERSD, IVERSR, MXLTC,  MXLTNS, 
     +			MXLNC,  MXLNNS, MAXBIN, MAXDEX, MXSTAT
C
	PARAMETER	( RMISS  = -99999.,
     +			  IVERSB = 9311, 
     +			  IVERSH = 5, 
     +			  IVERSD = 9311, 
     +			  IVERSR = 9311, 
     +			  DLAT   = 0.5,
     +			  DLONC  = 0.5,
     +			  DLONNS = 1.,
     +			  BNDRY  = 50.,
     +			  MXLTC  = ( 2 * BNDRY ) / DLAT,
     +			  MXLTNS = ( 90. - BNDRY ) / DLAT,
     +			  MXLNC  = 360 / DLONC,
     +			  MXLNNS = 360 / DLONNS,
     +			  MAXBIN = 32,
     +			  MAXDEX = 20,
     +			  MXSTAT = 20 )
C
C	Month boundary data.  For each month, the information is:
C	start pentad, days of start in month, stop pentad, days of
C	stop in month, number of days in month.
C
	INTEGER		mbounds (5, 12)
	DATA		mbounds /  1, 5,  7, 1, 31,   7, 4, 12, 4, 28,
     +			          12, 1, 18, 5, 31,  19, 5, 24, 5, 30,
     +				  25, 5, 31, 1, 31,  31, 4, 37, 1, 30,
     +				  37, 4, 43, 2, 31,  43, 3, 49, 3, 31,
     +				  49, 2, 55, 3, 30,  55, 2, 61, 4, 31,
     +				  61, 1, 67, 4, 30,  67, 1, 73, 5, 31 /
