	SUBROUTINE DMPIMGF  ( s1c, bnam, cp, flip, LN, LT, iret )
C************************************************************************
C* DMPIMGF  Dump a binary image to disk					*
C*									*
C* This subroutine dumps a binary image to disk.  The file name is	*
C* built from bnam and optionally a suffix of '.' and cp		*
C*									*
C* DMPIMGF  ( s1c, bnam, cs, cp, iret )					*
C*									*
C* Input parameters:							*
C*   s1c	REAL	Data field (size LN,LT)				*
C*   bnam	CHAR*	File basename					*
C*   cp 	CHAR*	Optional character id				*
C*   flip	LOG	T/F = do/don't flip field top-to-bottom		*
C*   LN		INT	X size						*
C*   LT		INT	Y size						*
C*									*
C* Output parameters:							*
C*   iret	INT	Return code: 0 = normal				*
C*				    <0 = -System error code		*
C**									*
C* Log:									*
C* G.Huffman/USRA	10/92	Adapt DMPIMGW				*
C* G.Huffman/SSAI	 2/96	Comment out color wedge			*
C* G.Huffman/SSAI	11/01	Clean-up				*
C************************************************************************
	IMPLICIT	NONE
	INTEGER*4	iunit,  nin,  i, j, jj, l_bn, l_cp, l_f
cc	REAL*4		wdg_n,  wdg_x
cc	REAL*4		sep (720)
	CHARACTER*256	file
C
	INTEGER*4	LN, LT, iret
	REAL*4		s1c (LN, LT)
	CHARACTER*(*)	bnam,   cp
	LOGICAL		flip
C
	INTEGER*4	INITW_DISK, WRITE_DISK, EXIT_DISK
C
C	Set iret and open the output file with a name built from the
C	basename and another parameter i.d.  The DO on the open allows
C	for another program temporarily locking the file that we're 
C	trying to write.
C
	iret  = 0
c	CALL ST_LSTR ( bnam, l_bn, iret )
c       get length of string excluding blanks (used to use ST_LSTR)
	l_bn = len(bnam)
	do i=l_bn,1,-1
	   if (bnam(i:i) .NE. ' ') then
	      l_bn=i
	      exit
	   endif
	enddo

	IF  ( cp (1:1) .NE. ' ' )  THEN
c          CALL ST_LSTR ( cp, l_cp, iret )
c          get length of string excluding blanks (used to use ST_LSTR)
	   l_cp = len(cp)
	   do i=l_cp,1,-1
	      if (cp(i:i) .NE. ' ') then
		 l_cp=i
		 exit
	      endif
	   enddo
	   
	   file = bnam (1:l_bn) // '.' //  cp (1:l_cp)
	   l_f  = l_bn + 1 + l_cp
	ELSE
	   file = bnam (1:l_bn)
	   l_f  = l_bn
	END IF
C       
	iunit = INITW_DISK ( file )
	IF  ( iunit .LT. 0 )  THEN
	    WRITE (*, *) 'Error', -iunit, ' opening ', file (1:l_f)
	    iret = iunit
	    RETURN
	END IF
C
C	Do the field, flipping if requested.
C
	IF  ( flip )  THEN
	    DO  j = 1, LT
		nin = WRITE_DISK ( iunit, s1c (1,  LT + 1 - j), LN * 4 )
	    END DO
	  ELSE
	    nin = WRITE_DISK ( iunit, s1c, LT * LN * 4 )
	END IF
ccC
ccC	Find the approximate max and min for drawing a color wedge.
ccC
cc	    wdg_n =  99999.
cc	    wdg_x = -99999.
cc	    DO  j = 1, LT, 5
cc	    DO  i = 1, LN, 5
cc		wdg_n = AMIN1 ( wdg_n, s1c (i, j) )
cc		wdg_x = AMAX1 ( wdg_x, s1c (i, j) )
cc	    END DO
cc	    END DO
C
ccC	    If the min and max are -.1 and about 1, assume that the
ccC	    field is percentages, with -.1 for "missing".
ccC
cc	    IF  ( wdg_n .EQ. -.1 .AND. 
cc     +		  wdg_x .GT. .95 .AND. wdg_x .LT. 1.01 )  THEN
cc		wdg_n = 0.
cc		wdg_x = 1.
cc	    END IF
ccC
cc	DO  i = 1, LN
cc	    sep (i) = wdg_n + ( wdg_x - wdg_n ) / 20. *
cc     +			      ANINT ( ( i - 1 ) * 20. / ( LN - 1 ) )
cc	END DO
cc	nin = WRITE_DISK ( iunit, sep, LN * 4 )
cc	nin = WRITE_DISK ( iunit, sep, LN * 4 )
cc	nin = WRITE_DISK ( iunit, sep, LN * 4 )
cc	nin = WRITE_DISK ( iunit, sep, LN * 4 )
cc	nin = WRITE_DISK ( iunit, sep, LN * 4 )
C
	iret = EXIT_DISK ( iunit )
	WRITE (*, *) 'Image file ', file (1:l_f), ' written'
C
	RETURN
	END
