function [RainCols] = Raincols(Nlevs);
% Produce rain rate colormap that is Nlevs long

% Written by MRP Spaiano, July 2012

if nargin~=1, disp('Insufficient input arguments.'); return; end;


% State colors to be interpolated in y
% and relative position of these colors in x
x=[0; 2; 4; 8; 12; 16; 20];
y=[1      1      1        % 0=White
   0      0.2    1        % 2=med-light blue
   0      1      1        % 4=cyan
   0      0.6667 0        % 8=darker green 
   1      1      0        % 12=yellow
   1      0.6667 0        % 16=orange
   1      0      0        % 20=red
];

% Now interpolate the colors
newx=0:(max(x)/Nlevs):max(x);
RainCols=[];
for i=1:3, RainCols(:,i)=interp1(x,y(:,i),newx); end;
