#include <stdio.h>
#include <time.h>
#include <sys/utsname.h>

#include "../../OptionsM_NRT.h"

int main(int argc, char *argv[])
{
  int    yyyy;
  int    mm;
  char   fname_cdr[256];
  char   VersNum[6];
  char  *CompName;

  // Establish time variables and structure fo robtaining local time
  time_t current_time_t;
  struct tm *current_time;
  char   current_time_str[256];

  // establish structure for getting unix system name
  struct utsname unameData;



  /* Get input arguments */
  yyyy = atoi(argv[1]);
  mm = atoi(argv[2]);

  /* Set version number - must be 6 digits
   * V22 reflects GPCP V2.2, rXX is release number and can change more often */
  //VersNum="v22rB1";
  sscanf(argv[3],"%6s",&VersNum);

  /* Obtain current time as seconds elapsed since the Epoch and convert to text */
  current_time_t = time(NULL);
  current_time = localtime(&current_time_t);
  sprintf(current_time_str,"%04d-%02d-%02dT%02d:%02d:%02dZ", 
	  1900+current_time->tm_year, 1+current_time->tm_mon, current_time->tm_mday, 
	  current_time->tm_hour, current_time->tm_min, current_time->tm_sec);

  /* Get Computer name */
  if ( uname(&unameData) == -1) {
    fprintf(stderr,"Can't get system name\n");
    CompName="unknown";
  }
  else {
    CompName=unameData.nodename;
  }

  /* Set output name (CDR or ICDR) */
  sprintf(fname_cdr,"gpcp_icdr_%s_y%04d_m%02d.nc",VersNum,yyyy,mm);

  /* Call function to create primary CDR file*/ 
  Write_ICDR_nc(OutputPATH,fname_cdr,VersNum,CompName,&current_time_str,yyyy,mm);

}
