#include <stdio.h>
#include <time.h>
#include <sys/utsname.h>

#include <sys/stat.h>
#include <openssl/md5.h>
#include <unistd.h>
#include <fcntl.h>

#include "../../OptionsM_NRT.h"

int main(int argc, char *argv[])
{
  int    yyyy;
  int    mm;
  int    yyyy1;
  int    mm1;
  char   fname_cdr[256];
  char   VersNum[6];
  char  *CompName;

  // Establish time variables and structure fo robtaining local time
  time_t current_time_t;
  struct tm *current_time;
  char   current_time_str[256];

  // establish structure for getting unix system name
  struct utsname unameData;

  /* Get input arguments */
  yyyy = atoi(argv[1]);
  mm = atoi(argv[2]);
  yyyy1 = yyyy;
  mm1 = mm + 1;
  if (mm1 > 12) {
    mm1 = mm1 - 12;
    yyyy1 = yyyy + 1;
  } 

  /* Set version number - must be 6 digits
   * V22 reflects GPCP V2.2, rXX is release number and can change more often */
  sscanf(argv[3],"%6s",&VersNum);

  /* Obtain current time as seconds elapsed since the Epoch and convert to text */
  current_time_t = time(NULL);
  current_time = localtime(&current_time_t);
  sprintf(current_time_str,"%04d-%02d-%02dT%02d:%02d:%02dZ", 
	  1900+current_time->tm_year, 1+current_time->tm_mon, current_time->tm_mday, 
	  current_time->tm_hour, current_time->tm_min, current_time->tm_sec);

  /* Get Computer name */
  if ( uname(&unameData) == -1) {
    fprintf(stderr,"Can't get system name\n");
    CompName="unknown";
  }
  else {
    CompName=unameData.nodename;
  }

  /* Set output name (CDR or ICDR) */
  //sprintf(fname_cdr,"gpcp_icdr_%s_y%04d_m%02d.nc",VersNum,yyyy,mm);
  sprintf(fname_cdr,"gpcp_%s-preliminary_monthly_d%04d%02d_c%04d%02d10.nc",VersNum,yyyy,mm,yyyy1,mm1);

  /* Call function to create primary CDR file*/ 
  Write_ICDR_nc(OutputPATH,fname_cdr,VersNum,CompName,&current_time_str,yyyy,mm);

  {
    int size = 0;
    char md5_sum[2*MD5_DIGEST_LENGTH+1] = {0};
    char data_file[128] = {0};
    sprintf(data_file, "%s/%s", OutputPATH, fname_cdr);
    size = get_size(data_file);
    if (get_MD5(data_file, md5_sum) && size) {
      FILE *fp = NULL;
      char info_file[128] = {0};
      sprintf(info_file, "%s/%s.mnf", OutputPATH, fname_cdr);
      fp = fopen(info_file, "w");
      if (fp) {
        fprintf(fp, "%s,%s,%d", fname_cdr, md5_sum, size);
        fclose(fp);
      }
    }
  }
}

int get_size(char *filename)
{
  int size = 0;
  struct stat st;
  stat(filename, &st);
  size = st.st_size;
  return size;
}

int get_MD5(char *filename, char *md5_sum)
{
  int n;
  MD5_CTX c;
  unsigned char out[MD5_DIGEST_LENGTH] = {0};
  char buf[512];
  ssize_t bytes;
  int fdc = open(filename, O_RDONLY);

  if (fdc) {
    MD5_Init(&c);
    bytes=read(fdc, buf, 512);
    while(bytes > 0)
    {
      MD5_Update(&c, buf, bytes);
      bytes=read(fdc, buf, 512);
    }

    MD5_Final(out, &c);

    for(n = 0; n < MD5_DIGEST_LENGTH; n++)
      sprintf(&md5_sum[2*n], "%02x", out[n]);
    md5_sum[2*n+3] = '\0';
    close(fdc);
    return 1;
  } else {
    printf("Unable to open file %s", filename);
    return 0;
  }
}
